;ASPECTS OF BANDLIMITING
;Ex.4, Bandlimited tables using Midi Pitch Numbers
;employs bandlimiting for frequency sweep
;using midipitch nums for tables.
;Then midi nums are converted back to freq for sweep
;SAVES TIME since only table per midi num is generated



<CsoundSynthesizer>
<CsOptions>

-+rtaudio=portaudio -odac 
csound -s -d -b4096 -B4096 

</CsOptions>
<CsInstruments>

sr	=	44100
kr	=	441
ksmps	=	100
nchnls	=	1


/* Create a rich sawtooth wave */
i_	ftgen 30000, 0, 16384, 7, 1, 16384, -1

/* generate bandlimited sawtooth waves for MIDI pitch nums */
i0	=  0
loop1:
imaxh	=  sr / (2 * 440.0 * exp (log(2.0) * (i0 - 69) / 12))
i_	ftgen i0, 0, 4096, -30, 30000, 1, imaxh
i0	=  i0 + 1
	if (i0 < 127.5) igoto loop1


;GEN16 ;create a straight line function of numbers from 1 to 128
i_	ftgen 30500, 0, 128, -16, 1, 127, 0, 128

;===================================================
;===================================================
;===================================================
	instr 1

;pulse thru the table once in time of p3
kphs phasor 0.043
ktable table kphs * 128, 30500, 0
printk2 ktable, 5

;convert midi pitch nums to hertz
kcps	=  440.0 * exp (log(2.0) * (ktable - 69) / 12)

;add portamento for freqs
kfrq    port  kcps, 0.09 
a2	oscilikt 2000, kfrq, ktable

out a2
	endin



</CsInstruments>
<CsScore>

i1 0 23

</CsScore>
</CsoundSynthesizer>
